/*
 * gngb2vdr.c: A plugin for the Video Disk Recorder
 *
 * See the README file for copyright information and how to reach the author.
 *
 * $Id$
 */

#include <getopt.h>
#include <stdio.h>
#include <pthread.h>
#include <semaphore.h>
#include <thread.h>
#include <plugin.h>

#include "SDL/SDL.h"
#include "osd.h"
#include "gbcosd.h"

#include "gbcplugin.h"

cPlugingbc2vdr::cPlugingbc2vdr(void)
{
  // Initialize any member variables here.
  // DON'T DO ANYTHING ELSE THAT MAY HAVE SIDE EFFECTS, REQUIRE GLOBAL
  // VDR OBJECTS TO EXIST OR PRODUCE ANY OUTPUT!

  strcpy( m_baseRomDirectory , "~/games/GameBoy" );

  initVdrgbcLog();

  FILE *f;
  f = fopen("vdr-gbc.log","at");
  if( f != NULL )
  {
    fprintf(f,"\n\n--- cgbcPlugin::cgbcPlugin() --- \n");
    fclose(f);
  }

}

cPlugingbc2vdr::~cPlugingbc2vdr()
{
  // Clean up after yourself!
}

const char *cPlugingbc2vdr::CommandLineHelp(void)
{
 // Return a string that describes all known command line options.
  return "  -d DIRECTORY, --romsdir=DIRECTORY   directory contains ROM files name\n"
         "                                      (default: '~/games/GameBoy')\n";
}

bool cPlugingbc2vdr::ProcessArgs(int argc, char *argv[])
{
   // Implement command line argument processing here if applicable.
   static struct option long_options[] = {
       { "romsdir", required_argument, NULL, 'r' },
       { NULL }
   };
   int c, option_index = 0;
   while ((c = getopt_long(argc, argv, "d:", long_options, &option_index)) != -1) {
      switch (c) {
        case 'd': strncpy(m_baseRomDirectory, optarg, sizeof(m_baseRomDirectory));
                  break;
        default:
                  isyslog("gbc: unknown command-line argument: '%s'", optarg);
                  break;
      }
   }
  return true;
}

bool cPlugingbc2vdr::Initialize(void)
{
  // Initialize any background activities the plugin shall perform.
  return true;
}

bool cPlugingbc2vdr::Start(void)
{
  // Start any background activities the plugin shall perform.
  return true;
}

void cPlugingbc2vdr::Housekeeping(void)
{
  // Perform any cleanup or other regular tasks.
}

cOsdObject *cPlugingbc2vdr::MainMenuAction(void)
{
  VDRGBCLOG("cPlugingbc2vdr::MainMenuAction\n");
  // Perform the action when selected from the main VDR menu.
  return new cgbcOsd(m_baseRomDirectory);
}

cMenuSetupPage *cPlugingbc2vdr::SetupMenu(void)
{
  // Return a setup menu in case the plugin supports one.
  return NULL;
}

bool cPlugingbc2vdr::SetupParse(const char *Name, const char *Value)
{
  // Parse your own setup parameters and store their values.
  return false;
}

VDRPLUGINCREATOR(cPlugingbc2vdr); // Don't touch this!
