///
///	@file dia.h		@brief diashow module header file
///
///	Copyright (c) 2009 - 2012 by Johns.  All Rights Reserved.
///
///	Contributor(s):
///
///	License: AGPLv3
///
///	This program is free software: you can redistribute it and/or modify
///	it under the terms of the GNU Affero General Public License as
///	published by the Free Software Foundation, either version 3 of the
///	License.
///
///	This program is distributed in the hope that it will be useful,
///	but WITHOUT ANY WARRANTY; without even the implied warranty of
///	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
///	GNU Affero General Public License for more details.
///
///	$Id: $
//////////////////////////////////////////////////////////////////////////////

typedef struct _image_ VdrImage;	///< vdr image typedef

extern VdrImage *VdrImageNew(unsigned, unsigned, const uint8_t *);
extern void VdrImageDel(VdrImage *);
extern unsigned VdrImageWidth(const VdrImage * const);
extern unsigned VdrImageHeight(const VdrImage * const);
extern uint8_t *VdrImageData(const VdrImage * const);

extern VdrImage *VdrImageLoadJPEG0(const char *, unsigned, unsigned);

extern void DrawText(int, int, const char *, uint32_t, uint32_t, int, int,
    int);
extern void DrawRectangle(int, int, int, int, uint32_t);
extern void DrawImage(const VdrImage *, int, int, unsigned, unsigned);

extern void DiaInit(void);		///< initialize dia module

    /// parse config
extern int DiaConfigParse(const char *, const char *);

    /// start dia-show
extern void DiaStart(const char *, unsigned, unsigned);
extern void DiaStop(void);		///< cleanup dia module
extern void DiaDraw(void);		///< draw dia

extern void DiaCmdUp(void);		///< up command
extern void DiaCmdDown(void);		///< down command
extern void DiaCmdLeft(void);		///< left command
extern void DiaCmdRight(void);		///< right command
extern void DiaCmdPageUp(void);		///< page up command
extern void DiaCmdPageDown(void);	///< page down command
extern void DiaCmdEnter(void);		///< enter command
extern void DiaCmdRotateLayout(void);	///< rotate layout command
extern void DiaCmdToggleFilmStrip(void);	///< toggle film-strip command
extern void DiaCmdRotateZoom(void);	///< rotate zoom mode
extern void DiaCmdRotateCounterClockwise(void);	///< rotate image 90 counterclockwise
extern void DiaCmdRotateClockwise(void);	///< rotate image 90 clockwise
extern void DiaCmdShrink(void);		///< shrink thumbnails
extern void DiaCmdGrow(void);		///< grow thumbnails
extern void DiaCmdInfo(void);		///< show image info
extern void DiaCmdToggleSlideShow(void);	///< start/stop slide-show
