/*
 * Copyright (C) 2006-2009 Alex Lasnier <alex@fepg.org>
 *
 * This file is part of Radio Info
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "menu.h"
#include "config.h"


///////////////////////////////////////////////////////////////////////////////


cRadioInfoSetupMenu::cRadioInfoSetupMenu(void)
{
  newMaxRetries  = config.maxRetries;
  newQuickDetect = config.quickDetect;
  newOsdDelay    = config.osdDelay;
   
  Add(new cMenuEditBoolItem("Use quick PID detection", &newQuickDetect, "No", "Yes"));
  Add(new cMenuEditIntItem("Max. retries for info",    &newMaxRetries, 1, 999)); 
  Add(new cMenuEditIntItem("OSD update delay (sec)",   &newOsdDelay, 0, 500)); 
}


//-----------------------------------------------------------------------------

void cRadioInfoSetupMenu::Store(void)
{
  SetupStore("maxRetries",  config.maxRetries  = newMaxRetries);
  SetupStore("quickDetect", config.quickDetect = newQuickDetect);
  SetupStore("osdDelay",    config.osdDelay    = newOsdDelay);
}


///////////////////////////////////////////////////////////////////////////////

