/*
 * Copyright (C) 2006-2009 Alex Lasnier <alex@fepg.org>
 *
 * This file is part of Radio Info
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __RADIO_INFO_OSD_H
#define __RADIO_INFO_OSD_H


#include <vdr/osd.h>
#include <vdr/thread.h>

#include "data.h"


///////////////////////////////////////////////////////////////////////////////


class cRadioInfoOsd : public cThread
{
public:
  cRadioInfoOsd(cRadioInfoData* Ri);
  virtual ~cRadioInfoOsd();

  void Stop(void);
  
protected:
  virtual void Action(void);
    
private:
  cOsd* rOsd;
  const cFont* font;
  
  static cBitmap header;
  static cBitmap notes;
  cBitmap canvas;
  
  const char* eventName;
  int offsetX, offsetY;
  int dirY;
  
  cRadioInfoData* radioInfoData;
  
  void Show(void);
  void Draw(void);
  void GetEventName(void);
  
  cCondWait condWait;
  cMutex osdMutex;
};


///////////////////////////////////////////////////////////////////////////////


#endif //__RADIO_INFO_OSD_H
