#ifndef __NOPACITY_DISPLAYMENU_H
#define __NOPACITY_DISPLAYMENU_H

class cNopacityDisplayMenu : public cSkinDisplayMenu , cThread{
private:
	cNopacityDisplayMenuView *menuView;
	cNopacityMenuDetailView *detailView;
	cOsd *osd;
	eMenuCategory menuCategoryLast;
	eMenuSubCategory menuSubCategory;
	eMenuSubCategory menuSubCategoryLast;
	int FrameTime;
	int FadeTime;
	bool initial;
	bool initMenu;
	bool diskUsageDrawn;
	int lastDiskUsageState;
	int lastTimersState;
	bool timersDrawn;
	int menuItemIndexLast;
	int currentNumItems;
	bool menuHasIcons;
	bool contentNarrow, contentNarrowLast;
	cList<cNopacityTimer> timers;
	cList<cNopacityMenuItem> menuItems;
	int handleBackgrounds[6];
	int handleButtons[4];
	void DrawDisk(void);
	void DrawTimers(void);
	void SplitItem(const char *Text, cString *strItems, int *tabItems);
	const char *channelName;
	virtual void Action(void);
public:
	cNopacityDisplayMenu(void);
	virtual ~cNopacityDisplayMenu();
	virtual void Scroll(bool Up, bool Page);
	virtual int MaxItems(void);
	virtual void Clear(void);
	virtual void SetMenuCategory(eMenuCategory MenuCategory);
	virtual void SetTitle(const char *Title);
	virtual void SetButtons(const char *Red, const char *Green = NULL, const char *Yellow = NULL, const char *Blue = NULL);
	virtual void SetMessage(eMessageType Type, const char *Text);
	virtual void SetItem(const char *Text, int Index, bool Current, bool Selectable);
	virtual void SetScrollbar(int Total, int Offset);
	virtual void SetEvent(const cEvent *Event);
	virtual void SetRecording(const cRecording *Recording);
	virtual void SetText(const char *Text, bool FixedFont);
	virtual void Flush(void);
};

#endif //__NOPACITY_DISPLAYMENU_H