#ifndef __LIVETICKER_H
#define __LIVETICKER_H


#if VDRVERSNUM >= 10509
#define OSDHASLEVEL
#endif
//#undef OSDHASLEVEL

class cLiveEvent : public cListObject
{
private:
	char *id;
	char *text;
	bool updated;
	bool touched;
	static bool updated4new;
	friend class cLiveTicker;
public:
	cLiveEvent(const char *Id, const char *Text);
	const char *Id() { return id; }
	void ClearFlags() { updated=touched=false; }
	bool Updated() { return updated; }
	bool Touched() { return touched; }
	void SetText(const char* Text);
	const char *Text() { return text; }
};

class cLiveTicker : public cThread, public cList<cLiveEvent>
{
public:
	cLiveTicker();
	~cLiveTicker();
protected:
	void Action(void);
private:
	static cLiveTicker* liveTicker;
	void Load(const char* File);
	bool DisplayMarquee(void);
public:
	static bool LiveTickerOsd;
	static cLiveTicker* LiveTicker()						{return liveTicker; }
	static void Update(bool Quiet=false);
	static cLiveEvent *First()								{ return liveTicker==NULL ? NULL : liveTicker->cList<cLiveEvent>::First(); }
	static cLiveEvent *Next(cLiveEvent *NextEvent)	{ return liveTicker==NULL ? NULL : liveTicker->cList<cLiveEvent>::Next(NextEvent); }
};
#ifndef OSDHASLEVEL
class cLiveTickerOsd : public cOsdObject, public cThread
{
public:
	cLiveTickerOsd();
	~cLiveTickerOsd();
	void Show(void);
	eOSState ProcessKey(eKeys Key);
protected:
	void Action(void);
};
#endif /* !OSDHASLEVEL */

#endif //__LIVETICKER_H

