#include <vdr/plugin.h>

#include "sportngtools.h"


char *DataDir			= NULL;
char *ScriptDir		= NULL;

int SplitString(char* String, char Char, char* Strings[], int Count)
{
	int ret_count=1;
	Strings[0] = String;
	for(int i=1; i<Count; i++)
	{
		char *p = strchr(String, Char);
		if (p)
		{
			*p++ = 0;
			Strings[i] = String = p;
			ret_count++;
		}
		else
		{
			for(; i<Count; i++)
				Strings[i] = 0;
			break;
		}
	}
	return ret_count; // returns real count of parts
}

time_t GetFileTime(const char* Filename)
{
	struct stat buf;
	return stat(cString::sprintf("%s/%s", DataDir, Filename),&buf)? 0 : buf.st_mtime;
}
int GetFileSize(const char* Filename)
{
	struct stat buf;
	return stat(cString::sprintf("%s/%s", DataDir, Filename),&buf)? 0 : buf.st_size;
}
time_t GetNextUpdate(bool FromFile/*=false*/)
{
	static time_t NextUpdate = 0;
	static bool FirstStart = true;
	if(FromFile || FirstStart)
	{
		FirstStart = false;
		time_t ret = 0;
		cString f_next_update = cString::sprintf("%s/%s", DataDir, "SportNG@NextUpdate");
		if(access(f_next_update, F_OK) == 0)
		{
			dsyslog("%s: loading %s", PLUGIN_NAME_I18N, (const char*)f_next_update);
			FILE *f = fopen(f_next_update, "r");
			if(f)
			{
				struct tm tm_r;
				fscanf(f, "%i-%i-%i %i:%i:%i", &tm_r.tm_year, &tm_r.tm_mon, &tm_r.tm_mday, &tm_r.tm_hour, &tm_r.tm_min, &tm_r.tm_sec);
				tm_r.tm_year -= 1900;tm_r.tm_mon -= 1;
				ret = mktime(&tm_r);
				fclose(f);
			}
		}
		return NextUpdate = ret;
	}
	return NextUpdate;
}

tColor FadeColor(tColor From, tColor To, int Fade) // Fade from 0=From - 255=To
{
	Fade = max(min(Fade, 255),0);
	uint8_t *pFrom = (uint8_t *)&From;
	uint8_t *pTo = (uint8_t *)&To;
	for(int i=0;i<4;i++)
		pFrom[i] += ((pTo[i] - pFrom[i]) * Fade) / 255;
	return From;
}


